var c_e c_l lab_e lab_l h_e h_l y lab k k_e k_l r_k dinv dinv_e dinv_l c a j theta g_e g_l p r_h w_e w_l b G z y_obs c_obs;

varexo ep ea ej ez;

parameters beta_e beta_l tau_c tau_s tau_k phi alph xi delt  eta pi rho_a  rho_z  rho_j gamm rho_p zeta omega1 omega2 omega4 omega5 ; 
         beta_e = 0.95;   
          beta_l = 0.95;  
          tau_c = 0.06;  
          tau_s = 0.18;  
          tau_k = 0.26;
          phi = 3.4; 
          alph = 0.476;  
          xi = 0.1832;  
          delt = 0.025;  
      
          eta = 0.1709; 
          pi = 0.5; 
          rho_a = 0.5; 
          rho_j = 0.5; 
        
          gamm =0.2189;
          zeta =0.1;
          rho_p =0.5;
          rho_z =0.75;
      
omega5=alph*beta_e*(1-tau_k)/(1+delt*beta_e-beta_e);
omega1=(1-delt*omega5-pi*zeta)*eta/2.129;
omega2=beta_e*(1+tau_c)/(1-beta_e); 
omega4=(1+tau_c)/(1-tau_s);
model;
%(1) educatied people's wage lab and consumption
w_e = (1+tau_c)/((1-tau_s)*z)*lab_e^(phi)*c_e;

%(2) nun-educatied people's consumption
w_l = (1+tau_c)/((1-tau_s)*z)*lab_l^(phi)*c_l;

%(3) Talent consumption across time
c_e/c_e(-1)=beta_e*((1-tau_k)*r_k+1-delt);

%(4)Talent intertemporal housing choice
j*beta_e/h_e-p/((1+tau_c)*c_e)+beta_e*p(+1)/((1+tau_c)*c_e(+1))=0;

%(5)nun-educatied consumption across time
k_e=(1-delt)*k_e(-1)+dinv_e;
 
%(6)nun-educatied intertemporal housing choice
j*beta_l/h_l-r_h/((1+tau_c)*c_l)+beta_l*r_h(+1)/((1+tau_c)*c_l(+1))=0;

%(7) Production function
y=a*k^alph*lab^(1-alph);

%(8) Wage margin function
xi*lab=lab_e+lab_l;

%(9) Marginal function of capital
r_k=alph*k^(alph-1)*lab^(1-alph);

%(10)Capital accumulation equation
k(+1)=(1-delt)*k+dinv;

%(11) The government balanced its budget for the current period
tau_c*c+tau_s*(w_e*lab_e+w_l*lab_l)/gamm+tau_k*(r_k-delt)*k=b+(g_e+g_l)/eta+G;

%(12) Aggregate housing demand
c_e/c_l=1.129;

%(13) Balance of production and consumption
c+dinv=y;

%(14) The composition of total consumption
eta*c=c_e+c_l+pi*(g_e+g_l);

%(15) The composition of total laber
k_e/k_l=1.396;

%(16) Talent migration rate
theta=lab_e/lab;

%(17)
dinv_e/dinv_l=1.396;

%(18) The composition of total investment
xi*dinv=dinv_e+dinv_l;

%(19) The composition of total captial
xi*k=k_e+k_l;

%(20) Constraint conditions of talent group
dinv_e+(1+tau_c)*c_e+p*(h_e-h_e(-1))+g_e-(1-tau_s)*w_e*lab_e-b-(1-tau_k)*r_k*k_e=0;

%(21) Constraint conditions of no-educated group
dinv_l+(1+tau_c)*c_l+r_h*(h_l-h_l(-1))+g_l-(1-tau_s)*w_l*lab_l-(1-tau_k)*r_k*k_l=0;

%(22) Rent expression
r_h=0.3*w_l;

%(23) The relationship between public consumption and output
g_e+g_l=eta*zeta*y;

%(24)ge yu gl
g_e/g_l=1.421;


%(25) Housing price shock
log(p)=rho_p*log(p(-1))+ep;

%(26) Production technology and impact
log(a)=rho_a*log(a(-1))+ea;

%(27)Housing demand shock
log(j)=rho_j*log(j(-1))+ej;

%(28)Labor supply shock
log(z)=rho_z*log(z(-1))+ez;

%(29)
y_obs=log(y)-log(y(-1));

%(30)
c_obs=log(c)-log(c(-1));

end;
initval;

a=1;
z=1;
j=1;
p=1;
y=40;
r_k=(1+delt*beta_e-beta_e)/((1-tau_k)*beta_e);
k=alph*beta_e*(1-tau_k)*y/(1+delt*beta_e-beta_e);
dinv=delt*alph*beta_e*(1-tau_k)*y/(1+delt*beta_e-beta_e);
c=(1-delt*omega5)*y;
c_l=omega1*y;
c_e=omega1*1.129*y;
g_l=zeta*eta*y/2.421;
g_e=zeta*eta*y*1.421/2.421;
lab=omega5^(alph/(alph-1))*y;
k_l=(xi/2.396)*omega5*y;
k_e=(1.396*xi/2.396)*omega5*y;
dinv_l=delt*(xi/2.396)*omega5*y; 
dinv_e=delt*(1.396*xi/2.396)*omega5*y;

lab_l=(((1+tau_c)*c_l+g_l+dinv_l-(1-tau_k)*r_k*k_l)/((1+tau_c)*c_l*z))^(1/(1+phi));
w_l=omega4*((dinv_l+(1+tau_c)*omega1*y+zeta*eta*y/2.421-(1-tau_k)*(1+delt*beta_e-beta_e)/((1-tau_k)*beta_e)*(xi/2.396)*omega5*y)/(1+tau_c)/(omega1*y)/z)^(phi/(phi+1))*omega1*y;

lab_e=xi*omega5^(alph/(alph-1))*y-lab_l;
w_e=omega4*lab_e^phi*c_e/z;
r_h=0.3*omega4*((dinv_l+(1+tau_c)*c_l+g_l-(1-tau_k)*r_k*k_l)/(1+tau_c)/c_l/z)^(phi/(phi+1))*c_l;

h_e=omega2*omega1*1.129*y*(j/p);
h_l=omega2*omega1*y/(0.3*(omega4*((dinv_l+(1+tau_c)*c_l+g_l-(1-tau_k)*r_k*k_l)/(1+tau_c)/c_l)^(phi/(phi+1))*c_l));

theta=(xi*lab-lab_l)/lab;
b=(1+tau_c)*c_e+g_e+dinv_e-(1-tau_s)*w_e*lab_e-(1-tau_k)*r_k*k_e;
G=tau_c*c+tau_s*(w_e*lab_e+w_l*lab_l)/gamm+tau_k*(r_k-delt)*k-(g_e+g_l)/eta-b;



end;

check;
steady;
model_diagnostics;

estimated_params;

rho_a, beta_pdf,0.5,0.1;  
rho_j, beta_pdf,0.5,0.1;
rho_p, beta_pdf,0.5,0.1;
rho_z, beta_pdf,0.75,0.1;
end;
estimated_params;
stderr ea,inv_gamma_pdf, 0.01, inf;
stderr ej,inv_gamma_pdf, 0.01, inf;
stderr ep,inv_gamma_pdf, 0.01, inf;
stderr ez,inv_gamma_pdf, 0.01, inf;
end;

varobs y_obs  c_obs ;

estimation(datafile=xiashi_bayes_data,conf_sig=.95,mode_check,mode_compute=0,mh_replic=2000,mh_jscale=0.2,mh_nblocks=2) c_e c_l lab_e lab_l h_e h_l y lab k k_e k_l r_k dinv dinv_e dinv_l c a j theta g_e g_l p r_h w_e w_l b G z;